<?php

namespace Treewec\DirectoryIterators;

/**
 * Test class for ComparatorFactory.
 * Generated by PHPUnit on 2012-07-03 at 17:45:35.
 * @group directory_iterators
 */
class ComparatorFactoryTest extends \PHPUnit_Framework_TestCase {

    public function testGet() {
        $comparatorTypes = $this->getClassConstants('\Treewec\DirectoryIterators\ComparatorType');
        $orderTypes = $this->getClassConstants('\Treewec\DirectoryIterators\OrderType');
        foreach ($comparatorTypes as $comparator) {
            if ($comparator == ComparatorType::NONE) {
                parent::assertFalse(ComparatorFactory::get($comparator));
            } else {
                foreach ($orderTypes as $order) {                
                    parent::assertInstanceOf('\Treewec\DirectoryIterators\BinderComparator', ComparatorFactory::get($comparator, $order));
                }
            }
        }
        // if invalid arguments -> default constans are user
        parent::assertInstanceOf('\Treewec\DirectoryIterators\BinderComparator', ComparatorFactory::get(array(), false));
    }
    
    private function getClassConstants($class) {
        $rf = new \ReflectionClass($class);
        return $rf->getConstants();
    }

}

?>
